=pod

A component of Matrix-Math© by Nova Software, Inc.

Copyright © by Nova Software, Inc. 2022  All rights reserved.  http://www.nova-sw.com
except for the core of the Lower-Upper (LU.pm) algorithm implementation, which is
Copyright (C) 2010 Ralph Schleicher. All rights reserved.

=cut
  package O_H; use strict; use warnings; use utf8; use Data::Dumper; use vars qw{@EXPORT @ISA}; use Exporter; my $wuH = '';  my $awH = '  '; 
my $vqH = yzH(); my $qnH = zfH(); my $qkH = tmH();  my $siH = o2H(); my $fsH = xzH(); my $saH = arH(); our $VERSION = 0.220304; use constant faH => '***ERROR***: '; @EXPORT  = qw{ faH gpH mpH owH yzH zfH tst_real_exp tst_complex_exp tmH o2H xzH
}; @ISA     = qw{Exporter}; sub yzH { qr/^-?\d*\.?\d+(e[+-]?\d+)?$/i } sub zfH { qr/^-?\d+$/ } our $Xpnts; BEGIN {$Xpnts = '[ˉ]?[¹²³⁴⁵⁶⁷⁸⁹]{1,3}'} our $Pi; BEGIN {$Pi = "π($Xpnts)?"} our $Smbl; BEGIN {$Smbl = "\\w+($Xpnts)?☀?∙?"} our $Imag; BEGIN { $Imag = "\\d*($Pi)?((î?($Smbl)*)|(î?($Smbl)*√\\d*($Pi)?($Smbl)+))"} our $Fctn_nms; BEGIN {$Fctn_nms = 'cos|sin|tan|cot|arccos|arcsin|arctan|exp|log|cosh|sinh|tanh'} sub tmH { qr/^-?(($Imag|\(($Imag[-\+]?)+\))  (\/$Imag)?)$              /x } sub o2H { qr/^-?\d*($Pi)?î?(($Smbl)*|(√\d*($Pi)?($Smbl)*))(($Fctn_nms)($Xpnts)?\(-?\w+\)∙?)+$/ } sub xzH {qr/^(-?[\w∙]*?)exp\((-?\w+)\)$/} 
sub arH {qr/^(-?[\w∙]*?)log\((-?[\w∙]+)\)$/} sub owH { my $paH = shift; return $paH unless $paH; return $paH if $paH=~/$vqH/;      my ($ppH,$gcH,$aqH) = split '/', $paH; defined $gcH or $gcH = '';    defined $aqH or $aqH = '';  warn faH."owH() called with two or more denominators: '$paH'" and return $paH if $aqH;  $gcH = yfH($gcH) if $gcH;  my $y1H = jhH(\$ppH);  my @rsH = frH($ppH);  $_ = yfH($_)  foreach (@rsH) ; my $sdH = join '+', @rsH;  $sdH =~s/\+-\s*/-/g; my $bmH = $gcH ? "/$gcH" : '' ;      return  @rsH>1 ? "$y1H($sdH)$bmH" : "$y1H$sdH$bmH" ;  } sub yfH { 
my $u2H = shift;  my $bmH = buH($u2H); my @dnH = huH($bmH) ; if ($dnH[3]) {  $dnH[0]=~s/^-// or  $dnH[0] = '-';  }        $dnH[4] = yeH($dnH[4]) if $dnH[4];  if ($dnH[5] ) { $dnH[5]=~s/exp\(-î/exp\(î/ or $dnH[5]=~s/exp\(î/exp\(-î/     if $dnH[5]=~/exp\((-?)î\w+\)/;   $dnH[5] = "∙$dnH[5]" if $dnH[4];   } $dnH[8] = yeH($dnH[8]) if $dnH[8];  return join '', @dnH;  } sub yeH {  my @pzH = split '∙', $_[0];  ($_=~s/☀$// or $_ .= '☀') foreach @pzH; return join '∙', @pzH;    }
sub mpH { my ($dvH,$bmH) = @_; $wuH .=$awH and print $wuH."begin mpH '$dvH'  '$bmH' \n" if $O_I::DEBUG=~/a/; if ( $dvH!~/./ or $bmH!~/./ ) { my ($csH, $v1H, $baH) = caller ; warn "mpH() called with missing summand from line '$baH' : '$dvH'  '$bmH' "; print $wuH."end 1 mpH '$dvH$bmH' \n" and $wuH=~s/$awH//  if $O_I::DEBUG=~/a/; return "$dvH$bmH"; } my $pgH = ''; if ($dvH=~/^0$/) {  $pgH = $bmH;  } elsif ($bmH=~/^0$/) { $pgH = $dvH; } elsif ($dvH=~$vqH and $bmH=~$vqH) {  $pgH = $dvH+$bmH; }
elsif ($dvH=~/\./ or $bmH=~/\./) { my ($csH,$v1H,$baH) = caller; warn faH."mpH(): Cannot mix operations on decimals, expressions and floating point numbers. \n". "$O_I::Oc '$dvH'\n'$bmH'\n$O_I::Oc No sum. Called from line '$baH' ." ; print $wuH."end 2 mpH '$dvH$bmH' \n" and $wuH=~s/$awH//  if $O_I::DEBUG=~/a/; return 0; } elsif ($dvH!~/\+|.-/ and $bmH!~/\+|.-/ ) { $pgH = jzH($dvH,$bmH); } else {  my ($ytH,$ecH,$mxH) = split '/', $dvH; my ($wyH,$gxH,$jiH) = split '/', $bmH; if (defined $mxH or defined $jiH) { my ($csH,$v1H,$baH) = caller; die "mpH() One or both inputs '$dvH' & '$bmH' contain multiple denominators.\n". "Called from line '$baH'."; return 0; }
defined $ecH or $ecH = '';  defined $gxH or $gxH = '';  my $rwH = '';  my $biH = '';  my $clH = '';  if ($ecH and $gxH) { if ($ecH eq $gxH) { $rwH = $ecH; } else { $rwH = wvH($ecH,$gxH);  $biH = $gxH; $clH = $ecH; } } elsif ($ecH and not $gxH ) { $rwH = $clH = $ecH; } elsif ($gxH and not $ecH ) { $rwH = $biH = $gxH;
} else {}  my $ypH = jhH(\$ytH);  my $nrH = jhH(\$wyH); my @wcH = frH($ytH);  my @pmH = frH($wyH); if ($ypH) { $_ = wvH(-1,$_) foreach @wcH; } if ($nrH) { $_ = wvH(-1,$_) foreach @pmH; } if ($biH) {  $_ = wvH($biH,$_)  foreach (@wcH); } if ($clH) {  $_ = wvH($clH,$_) foreach (@pmH); } my @ljH = (@wcH,@pmH); @ljH = dhH(@ljH); nyH(\@ljH,\$rwH); my $ppH = join '+', @ljH; $ppH =~s/\+\s*\-/\-/g; my $gcH = ($rwH and ($rwH ne 1)) ? "/$rwH" : '';
$pgH = @ljH>1 ? "($ppH)$gcH" : "$ppH$gcH"; }  print $wuH."end 3 mpH '$pgH' \n" and $wuH=~s/$awH// if $O_I::DEBUG=~/a/; $pgH; } sub jhH { my $fyH = shift; my $zzH = ''; if ( $$fyH=~/^(-?)\((.+)\)$/ ) { $zzH = $1;  $zzH ||= ''; $$fyH=$2; } return $zzH; } sub frH { my $paH = shift; $paH=~s/\+/±/g; $paH=~s/\(-/\(¢/g;   $paH=~s/-/±-/g; $paH=~s/¢/-/g;  
$paH=~s/^±//;   $paH=~s/±±/±/g;  return split '±', $paH; } sub jzH { my ($dvH, $bmH) = @_; $wuH .=$awH and print $wuH."begin jzH() '$dvH'  '$bmH' \n" if $O_I::DEBUG=~/b/; my $pgH = ''; my $mtH = 0; if ($dvH!~/./ and $bmH!~/./) { $mtH = 1 } elsif ($dvH!~/./) { $pgH = $bmH; $mtH = 1; } elsif ($bmH!~/./) { $pgH = $dvH; $mtH = 1; } if ($mtH) {
warn "jzH() called with empty value(s) '$dvH'  '$bmH' \n" if $O_I::DEBUG=~/be/; print $wuH."end 1 jzH() '$pgH' \n" and $wuH=~s/$awH//  if $O_I::DEBUG=~/b/; return $pgH; } if ($dvH=~/^(-)?\d+(\/\d+)?$/ and $bmH=~/^(-)?\d+(\/\d+)?$/) { $pgH = mvH ($dvH, $bmH) } elsif ($dvH=~/\// or $bmH=~/\//) { $pgH = nsH($dvH,$bmH) } else { $pgH = dhH($dvH,$bmH) }  print $wuH."end 2 jzH() '$pgH' \n" and $wuH=~s/$awH//  if $O_I::DEBUG=~/b/; return $pgH; } sub mvH { my ($dvH,$bmH)  = @_; $wuH .=$awH and print $wuH."begin mvH() '$dvH'  '$bmH' \n" if $O_I::DEBUG=~/c/;
my ($ypH, $ytH, $ecH) = ('','',''); if ($dvH=~/^(-)?(\d+)(\/(\d+))?$/) { $ypH = $1 ? -1 : 1 ; $ytH = $2; $ecH = $4 ? $4 : 1; } else { warn faH."mvH(): First arg is not a rational:  '$dvH' "; print $wuH."end 1 mvH()  '$dvH'  '$bmH' \n" and $wuH=~s/$awH//  if $O_I::DEBUG=~/c/; return $bmH; } my ($nrH, $wyH, $gxH) = ('','',''); if ($bmH=~/^(-)?(\d+)(\/(\d+))?$/)  { $nrH = $1 ? -1 : 1 ; $wyH = $2; $gxH = $4 ? $4 : 1; } else { warn faH."mvH(): Second arg is not a rational:  '$bmH' " ;
print $wuH."end 2 mvH()  '$dvH'  '$bmH \n" and $wuH=~s/$awH//  if $O_I::DEBUG=~/c/; return $dvH; } my $rhH = 1; if ($ecH>1 and $gxH>1) { $rhH = cvH($ecH,$gxH) } else { $rhH = $ecH * $gxH }  my $ppH = ($ypH * $ytH) * ($rhH/$ecH) + ($nrH * $wyH) * ($rhH/$gxH); ($ppH,$rhH) = znH($ppH,$rhH); ($ppH,$rhH) = sxH($ppH,$rhH); my $sdH = $ppH.'/'.$rhH; print $wuH."end 2 mvH() '$sdH' \n" and $wuH=~s/$awH//  if $O_I::DEBUG=~/c/; return $sdH; } sub cvH { my ($dvH,$bmH) = @_; warn faH."cvH() called with at least one non-integer '$dvH'  '$bmH' .\n" and return ($dvH,$bmH) unless ($dvH=~$qnH and $bmH=~$qnH); return (abs($dvH)/pkH($dvH,$bmH))*abs($bmH); 
} sub pkH { my ($dvH, $bmH) = @_; warn faH."pkH() called with at least one non-integer  '$dvH'  '$bmH' \n" and return 1 unless ($dvH=~$qnH and $bmH=~$qnH); while ($bmH!= 0) { my $lrH = $bmH; $bmH = $dvH%$bmH; $dvH = $lrH; } return $dvH if $dvH > -$dvH ; return -$dvH ; } sub nsH { my ($dvH,$bmH) = @_; $wuH .=$awH and print $wuH."begin nsH() '$dvH'  '$bmH' \n" if $O_I::DEBUG=~/b/; $dvH=~/^(-)?(.+?)(\/(.+))?$/; my $ypH = $1 ? '-' : '' ; my $ytH = $2;   my $ecH = $4 ? $4 : '';
$bmH=~/^(-)?(.+?)(\/(.+))?$/; my $nrH = $1 ? '-' : '' ; my $wyH = $2;  my $gxH = $4 ? $4 : ''; my $pgH = ''; if ( ($wyH eq $ytH) and ($nrH ne $ypH) ) { print $wuH."end 1 nsH() '$pgH' \n" and $wuH=~s/$awH//  if $O_I::DEBUG=~/b/; return 0; } if (not $ecH and not $gxH) { warn "Missing both denominators in nsH().\n"; print $wuH."end 2 nsH() '$pgH' \n" and $wuH=~s/$awH//  if $O_I::DEBUG=~/b/; $pgH = "$dvH+$bmH"; } elsif ($ecH and not $gxH) { my $tmp = wvH("$nrH$wyH",$ecH);  $pgH = dhH("$ypH$ytH",$tmp)."/$ecH"; }
elsif ($gxH and not $ecH) { my $tmp = wvH("$ypH$ytH",$gxH);  $pgH = dhH($tmp,"$nrH$wyH")."/$gxH"; } elsif ($ecH eq $gxH) {  $pgH = dhH("$ypH$ytH","$nrH$wyH")."/$ecH"; } else {  my $tmp_d = wvH($ecH,$gxH);  $tmp_d = $tmp_d ? "/$tmp_d" : '' ; my $tmp_o = wvH("$ypH$ytH",$gxH); my $tmp_t = wvH("$nrH$wyH",$ecH); $pgH = dhH($tmp_o,$tmp_t)."$tmp_d"; } print $wuH."end 3 nsH() '$pgH' \n" and $wuH=~s/$awH//  if $O_I::DEBUG=~/b/; return $pgH } sub dhH { my @ohH = @_;
$wuH .=$awH and print $wuH."begin dhH '@ohH' \n" if $O_I::DEBUG=~/d/; my @oeH = ();  my @vwH = ();  my %wlH = (); while (@ohH) { my $g3H = shift @ohH; next unless $g3H; my ($ivH, $vyH, $qbH) = ggH($g3H); my $chH = "$ivH$vyH"; my $akH = 0; my @s2H = (); my $aeH = 0; foreach (@ohH) { my ($vlH, $wtH, $mbH) = ggH($_) ; if ( ($mbH and ($qbH eq $mbH))  or (!$qbH and !$mbH) ) {  $chH += "$vlH$wtH" if $wtH; push @s2H, $akH; $aeH = 1;
} $akH++; } if ($aeH) { push @oeH, "$chH$qbH" if $chH;  my @njH = reverse @ohH; splice(@njH, -$_-1, 1) foreach reverse @s2H; @ohH = reverse @njH; } else { push @vwH, $g3H; } } my @vuH = (@oeH,@vwH); push @vuH,0 unless @vuH; my $pgH = join('+', @vuH); $pgH =~s/\+\s*\-/\-/g; $pgH = "($pgH)"  if @vuH > 1 ; print $wuH."end dhH() '@vuH'  or   '$pgH' \n" and $wuH=~s/$awH//  if $O_I::DEBUG=~/d/;
return wantarray ? @vuH : $pgH ; } sub ggH { my $bhH = shift; $bhH =~/^(-?)(\d*)(.+)$/;   my $lxH = $1 ? $1 : ''; my $agH = $2 ? $2 : 1; my $kbH = $3 ? $3 : ''; return ($lxH, $agH, $kbH) } sub znH { my ($ppH,$rhH) = @_; while ($ppH=~/0$/ and $rhH=~/0$/) { chop $ppH; chop $rhH ; } return ($ppH,$rhH) } my @cqH = (2,3,5,7,11,13,17,19,23,29,31,37,41,43,47,53,59,61,67,71,73,79,83,89,97, 101,103,107,109,113,127,131,137,139,149,151,157,163,167,173,179,181,191,193,197);
sub sxH { my ($ppH, $rhH) = @_; foreach (@cqH) { last if ($_ > abs($ppH) or $_ > $rhH); until ($ppH%$_ or $rhH%$_) { $ppH=$ppH/$_; $rhH=$rhH/$_; } } return ($ppH, $rhH); } sub pjH { my $sdH = shift; my ($ppH, $gcH, $aqH) = split '/', $sdH; $aqH ||=''; warn faH."pjH() called with non-rational argument: $sdH .\n" unless ($ppH=~$qnH and $gcH=~$qnH and not $aqH); my $xxH = 0; while ($ppH > $gcH ) { $ppH = $ppH-$gcH; $xxH++;
} return $xxH ? "$xxH+$ppH/$gcH" : $sdH ; } sub gpH { my ($dvH,$bmH) = @_;  $wuH .=$awH and print $wuH."begin gpH() '$dvH'  '$bmH'\n" if $O_I::DEBUG=~/3/; defined $dvH or $dvH = 1; defined $bmH or $bmH = 1; my $pgH = ''; if ($dvH=~/^0+$/ or $bmH=~/^0+$/) {  $pgH = 0; } elsif ($dvH=~/^(-?)1$/){  if ($1) { $bmH=~s/^\+//;   $bmH=~s/^-// or $bmH = "-$bmH"; } $pgH = $bmH=~/^-?\w+[\+-]\w+$/ ? "($bmH)" : $bmH ;  } elsif ($bmH=~/^(-?)1$/) {
if ($1) { $dvH=~s/^\+//;   $dvH=~s/^-// or $dvH = "-$dvH"; } $pgH = $dvH=~/^-?\w+[\+-]\w+$/ ? "($dvH)" : $dvH ; } elsif ($dvH=~$vqH and $bmH=~$vqH) { $pgH = $dvH*$bmH; } elsif ($dvH=~/\./ or $bmH=~/\./) { my ($csH,$v1H,$baH) = caller; warn faH."gpH() cannot mix operations on decimals or floating point numbers \n". "with expressions in this release. No product. Called from line '$baH' ." ; print $wuH."end 1 gpH() '$pgH' \n"  and $wuH=~s/$awH// if $O_I::DEBUG=~/3/; return 0; } else { my ($ytH,$ecH,$mxH) = split '/', $dvH; my ($wyH,$gxH,$jiH) = split '/', $bmH; if (defined $mxH or defined $jiH) {
my ($csH,$v1H,$baH) = caller; warn faH."gpH() One or both inputs '$dvH' & '$bmH' contain multiple denominators.\n". "Called from line '$baH'."; print $wuH."end 2 gpH() '$pgH' \n"  and $wuH=~s/$awH// if $O_I::DEBUG=~/3/; return 1; } my $rwH = wvH($ecH,$gxH);  my $zzH = jhH(\$ytH);  $zzH .= jhH(\$wyH); $zzH = '' if $zzH eq '--' ; my @wcH = frH($ytH); my @pmH = frH($wyH); my @ljH = (); foreach my $xxH (@wcH) { next unless $xxH;  foreach my $ihH (@pmH) { next unless $ihH; my $cuH = wvH($xxH,$ihH); if ($zzH) {$cuH = wvH(-1,$cuH)} push @ljH, $cuH;
} } @ljH = dhH(@ljH); nyH(\@ljH, \$rwH); my $ppH = ''; my $gcH = ''; if (@ljH) { $ppH = join '+', @ljH;  $ppH =~s/\+\s*-/\-/g; $ppH = "($ppH)" if @ljH>1  ; } else { warn "Zero numerator in multiplication." ;  print $wuH."end 2 gpH() '0' \n" and $wuH=~s/$awH// if $O_I::DEBUG=~/3/; return 0; } if ($rwH and $rwH !~/^1$/ ) { $gcH = "/$rwH" ; }
$pgH = "$ppH$gcH"; } print $wuH."end 3 gpH() '$pgH' \n" and $wuH=~s/$awH// if $O_I::DEBUG=~/3/; return $pgH; } sub wvH { my ($ueH, $icH) = @_; defined $ueH or $ueH = ''; defined $icH or $icH = ''; $wuH .=$awH and print $wuH."begin wvH '$ueH'  '$icH' \n" if $O_I::DEBUG=~/4/; if (($ueH!~/./ or $icH!~/./) ) { print $wuH."end 1 wvH() '' \n" and $wuH=~s/$awH// if $O_I::DEBUG=~/4/; return $ueH.$icH; } my $sdH = euH($ueH,$icH) ;   if ($sdH) { print $wuH."end 2 wvH() '$sdH' \n" and $wuH=~s/$awH//  if $O_I::DEBUG=~/4/;
return $sdH; } my $dvH = buH($ueH);  my $bmH = buH($icH); my @wcH; my @pmH; push @wcH, shift @$dvH while (@$dvH and $dvH->[0] ne '/'); push @pmH, shift @$bmH while (@$bmH and $bmH->[0] ne '/'); my @rsH = qgH(\@wcH,\@pmH); l5H(\@rsH); my @htH = qgH($dvH, $bmH); l5H(\@htH); ymH(\@rsH,\@htH); $rsH[1] = '' if ($rsH[1] and $rsH[1]==1 and ($rsH[2] or $rsH[3] or $rsH[4] or $rsH[5] or $rsH[6])); my $tpH = ''; if ($rsH[1]=~/^0/) { $tpH = 0; } else { defined $_ or $_ = '' foreach @rsH; $tpH = join '', @rsH[0..4];
$tpH .= '∙'.$rsH[5] if $rsH[5]=~/./; $tpH .= join '', @rsH[6..9];  } $tpH = -1 if $tpH eq '-'; $tpH = 1 unless $tpH=~/./; $sdH = $tpH.join '', @htH;   print $wuH."end 3 wvH() '$sdH' \n" and $wuH=~s/$awH//  if $O_I::DEBUG=~/4/; return $sdH; } sub euH { my ($ueH, $icH) = @_; my $sdH = ''; if ($ueH=~$fsH and $icH=~$fsH) {  my ($t1H, $szH) = ($1, $2); $ueH=~$fsH; my ($zqH, $zgH) = ($1, $2); my $srH = wvH($zqH, $t1H);  my $hgH = mpH($zgH, $szH); if ($hgH=~$vqH and $hgH==0) {
$sdH = $srH=~/./ ? $srH : 1; } else { $srH .= '∙'  if $srH =~/./; $sdH = $srH."exp($hgH)"; } } elsif ($ueH=~$fsH) { my ($zqH, $zgH) = ($1, $2); my $srH = wvH($zqH, $icH);  $srH .= '∙'  if $srH =~/./; $sdH = $srH."exp($zgH)"; } elsif ($icH=~$fsH) { my ($t1H, $szH) = ($1, $2); my $srH = wvH($t1H, $ueH);  $srH .= '∙'  if $srH =~/./; $sdH = $srH."exp($szH)"; } return $sdH;
} sub buH { my $paH = shift; $wuH .=$awH and print $wuH."begin buH $paH \n" if $O_I::DEBUG=~/4.1/; my @gmH = split //, $paH;  my @zyH = ();  my $jwH = ''; my $s1 = '';  $_ = shift @gmH; while (defined $_ ) { if (/^-$/) { push @zyH, $_ }  elsif (/^[\/√]$/) {  push @zyH, $jwH if $jwH=~/./; push @zyH, $s1 if $s1=~/./; push @zyH, 1 unless ($jwH=~/./ or $s1);  $jwH = $s1 = ''; push @zyH, $_; } elsif (/^\d$/) { if ($s1) { $s1 .=$_} else {$jwH .=$_}
} elsif (/^π$|^î$/) { push @zyH, $_ } else {  if (/∙/) { push @zyH, $s1 if $s1=~/./; $s1 = ''; }  else {  $s1 .=$_; push @zyH, $jwH if $jwH=~/./;  $jwH = ''; if ($s1=~/$Fctn_nms/) { do {  $_ = shift @gmH; $s1 .= $_ ; } until /\)/;  push @zyH, $s1  if $s1=~/./; $s1 = '';  } }
} $_ = shift @gmH; } push @zyH, $jwH if $jwH=~/./;  push @zyH, $s1 if $s1=~/./; print $wuH."end buH '@zyH' \n" and $wuH=~s/$awH//  if $O_I::DEBUG=~/4.1/; return (\@zyH); } my @waH = ('[-\/]','\d+',"π($Xpnts)?",'î',"(\\w+☀?($Xpnts)?∙?)+", "(($Fctn_nms)($Xpnts)?\\(-?(\\w+☀?($Xpnts)?∙?)+\\)∙?)+", '√√','√\d+',"√π($Xpnts)?","√(\\w+☀?($Xpnts)?∙?)*" ); sub huH { my $zuH = shift; $wuH .=$awH and print $wuH."begin huH '@$zuH' \n" if $O_I::DEBUG=~/5/; my @ouH; my @xgH;   my $etH = ''; foreach (@$zuH) { 
$etH = '√' if $_ eq '√'; push @xgH, "$etH$_"; } print $wuH."'@xgH'\n" if $O_I::DEBUG=~/5.1/; foreach my $xxH (@waH) { my %rpH = (); my $akH = 0; foreach (@xgH) { next unless /./; if (/^$xxH$/) { $rpH{$akH} = $_ ; $rpH{$akH} =~s/√//;  } $akH++; } my ($sdH,$nvH) = ('',0); foreach (sort{$a<=>$b} keys %rpH) {  my $dzH = @xgH; print $wuH.$awH.">  '$_'  '$nvH'  '@xgH'  '$dzH' }' \n"  if $O_I::DEBUG=~/5.1/; splice @xgH, $_ - $nvH++, 1 ; 
$sdH .= $sdH ? "∙$rpH{$_}" : $rpH{$_}; } push @ouH, $sdH; print $wuH."in: '@xgH'  out: '@ouH' \n"  if $O_I::DEBUG=~/5.1/; } my $upH = join '', @xgH;  warn "Canonicalize() failed to process all inputs, leaving '@xgH' . " if @xgH; print $wuH."end huH '@ouH' \n" and $wuH=~s/$awH// if $O_I::DEBUG=~/5/; return @ouH; } $" = ',' if $O_I::DEBUG>2;  sub qgH { my ($dvH,$bmH) = @_; return () unless (@$dvH or @$bmH);  $wuH .=$awH and print $wuH."begin qgH  '@$dvH'  '@$bmH' \n" if $O_I::DEBUG=~/6/; my @zyH = huH($dvH);  my @gmH = huH($bmH); my @mnH;
my $zqH = ''; my $t1H = '';   foreach my $akH (0 .. 9) { my $dvH = shift @zyH; my $bmH = shift @gmH; if ($akH==6 and ($zqH=~$qnH and $t1H=~$qnH) ){ $mnH[1] = $zqH * $t1H unless $mnH[1];  $zqH = $t1H = ''; } if ($dvH=~/./ and $bmH=~/./) {  if ($akH==0) { push @mnH, $dvH eq '-' ? '' : '/'  } elsif ($akH==1) {  unless ($zyH[3] or $gmH[3]) {  push @mnH, $dvH * $bmH ; } else {  push @mnH, ''; $zqH = $dvH; $t1H = $bmH;
} } elsif ($akH==2) {  my $amH = ''; if ($zqH=~$qnH and $t1H=~$qnH) {  my $amH = $zqH*$t1H; $zqH = $t1H = ''; push @mnH, $amH."π²"; } } elsif ($akH==3) {  $mnH[0] = $mnH[0] eq '-' ? '' : '-'; push @mnH, ''; } elsif ($akH==4) {  if ($zqH=~$qnH and $t1H=~$qnH) {  my $tmp = $zqH * $t1H; $zqH = $t1H = ''; if ($mnH[1]=~$qnH) { $mnH[1] += $tmp;
} else { $mnH[1] = $tmp; } push @mnH, pfH($dvH,$bmH);                     } else { push @mnH, pfH($dvH,$bmH); } } elsif ($akH==5) {  if ($dvH=~$fsH and $bmH=~$fsH) { my ($t1H, $szH) = ($1, $2); $dvH=~$fsH; my ($zqH, $zgH) = ($1, $2); my $srH = wvH($zqH, $t1H);  my $hgH = mpH($zgH, $szH); if ($hgH=~$vqH and $hgH==0) { push @mnH, $srH=~/./ ? $srH : 1; }
else { $srH .= '∙'  if $srH =~/./; push @mnH, $srH."exp($hgH)"; } } else { if ($dvH eq $bmH) {  my $q4H = gfH($dvH); my $xxH = ahH($q4H,$q4H);  if ($dvH=~/∙/ ) {  if ($dvH=~/\((.*)\)$q4H/) {  push @mnH, "($1)$xxH";   } else {  push @mnH, "($dvH)$xxH";   } } else {  if ( $dvH=~/$q4H\(/ ) {  $dvH=~s/$q4H/$xxH/e;
push @mnH, $dvH ; } else {  $dvH=~/($Fctn_nms)(.+)/;  push @mnH, "$1$xxH$2"; } }  }  else { push @mnH, "$dvH∙$bmH"; }  }  } elsif ($akH==6) { push @mnH, '√'} elsif ($akH==7) {  if (not $zyH[1] and not $gmH[1]) {  push @mnH, $dvH * $bmH } else { $zqH = $dvH;  $t1H = $bmH; } } elsif ($akH==8) { if ($zqH=~$qnH and $t1H=~$qnH) { 
push @mnH, $zqH*$t1H."π²"; $zqH = $t1H = ''; } else { push @mnH, "π²" } } elsif ($akH==9) {  if ($zqH=~$qnH and $t1H=~$qnH) {  my $tmp = $zqH * $t1H; $zqH = $t1H = ''; if ($mnH[1]=~$qnH) { $mnH[1] += $tmp; } else { $mnH[1] = $tmp; } push @mnH, pfH($dvH,$bmH); } else { push @mnH, pfH($dvH,$bmH); }
} } elsif ($dvH!~/./) {push @mnH, $bmH} elsif ($bmH!~/./) {push @mnH, $dvH} else {push @mnH, ''} } print $wuH."end qgH '@mnH' \n" and $wuH=~s/$awH// if $O_I::DEBUG=~/6/; return @mnH } sub pfH { my ($dvH,$bmH) = @_; $wuH .=$awH and print $wuH."begin pfH  '$dvH'   '$bmH'  \n"   if $O_I::DEBUG=~/7/; my $sdH = '';  if($dvH!~/./ or $bmH!~/./) { $sdH = "$dvH$bmH";  print $wuH."end 1 pfH '$sdH' \n"  and $wuH=~s/$awH// if $O_I::DEBUG=~/7/ ; return $sdH; 
} my @mnH = (); my @krH = ();  my @zyH = split '∙', $dvH;  my @gmH = split '∙', $bmH;  my %p1H = map {$_ => '' }  @gmH;   foreach my $hbH (@zyH) { my $aeH = 0; foreach my $u3H (@gmH)  { $hbH =~/((\w+☀?)($Xpnts)?)/; my $muH = $2; my $mxH = $3; $muH ||= ''; $u3H =~/((\w+☀?)($Xpnts)?)/; my $jlH = $2; my $jiH = $3; $jlH ||= ''; if ($muH and $jlH and $muH eq $jlH) { $mxH ||= '¹'; $jiH ||= '¹'; push @krH, $muH.ahH($mxH,$jiH); $p1H{$u3H} = $aeH = 1;  }
} push @mnH, $hbH if not $aeH;  } foreach (keys %p1H) { push @mnH, $_ unless $p1H{$_}; }  $sdH = join '∙', sort (@krH, @mnH); print $wuH."end 2 pfH '$sdH' \n"  and $wuH=~s/$awH// if $O_I::DEBUG=~/7/ ; return $sdH; } sub kaH { my $paH = shift; my @xsH = sort split '∙', $paH; return join '∙', @xsH; } sub gfH { my $odH = shift;  my $hgH = '¹'; if ($odH=~/\)($Xpnts)$/) {
return $1 } elsif ($odH=~/^($Fctn_nms)($Xpnts)\(/) {  return $2; } else { return $hgH } } {  sub ahH { my ($dvH,$bmH) = @_; $dvH=~tr/ˉ⁰¹²³⁴⁵⁶⁷⁸⁹/-0123456789/; $bmH=~tr/ˉ⁰¹²³⁴⁵⁶⁷⁸⁹/-0123456789/; my $nvH = $dvH + $bmH ; return '' if $nvH == 1;  $nvH=~tr/-0123456789/ˉ⁰¹²³⁴⁵⁶⁷⁸⁹/; return $nvH;  } }  sub l5H { my $dlH = shift;
return unless @$dlH == 10;  return unless $dlH->[6];  my ($ppH, $akH) = uvH($dlH->[7]); if ($ppH) {  $dlH->[7] = $akH; if ($dlH->[1]=~/^\d+$/) {  $dlH->[1] = $dlH->[1] * $ppH;  } else {$dlH->[1] = $ppH; } } $dlH->[7] = '' if ( $dlH->[7] and $dlH->[7]==1 ) ; $dlH->[6] = '' unless ($dlH->[7] or $dlH->[8] or $dlH->[9]); return; } {  my %xbH = (1=>1, 4=>2, 9=>3, 16=>4, 25=>5, 36=>6, 49=>7, 64=>8, 81=>9, 100=>10, 121=>11, 144=>12, 169=>13, 196=>14, 225=>15, 256=>16, 289=>17, 324=>18, 361=>19, 400=>20, 441=>21, 484=>22, 529=>23, 576=>24, 625=>25, 676=>26, 729=>27, 784=>28, 841=>29, 900=>30, 961=>31,
1024=>32); sub uvH { my $akH = shift; return ('', $akH) unless $akH;  return ($xbH{$akH}, 1) if exists $xbH{$akH};  return ('', $akH); } }  sub ymH { my ($ppH,$gcH) = @_; warn "ymH()--no numerator." unless @$ppH; return unless (@$ppH==10 and @$gcH==10);  $wuH .=$awH and print $wuH."begin ymH() '@$ppH'  '@$gcH' \n" if $O_I::DEBUG=~/8/; if ($ppH->[1]=~/^\d+$/ and $gcH->[1]=~/^\d+$/) { die "ymH()--Denom is 0." if ($gcH->[1]==0 or $ppH->[1]==0 ); my $xxH = $ppH->[1]/$gcH->[1]; my $ihH = $gcH->[1]/$ppH->[1]; if ($xxH!~/\./) {
$ppH->[1] = $xxH; $gcH->[1] = ''; } elsif ($ihH!~/\./) { $gcH->[1] = $ihH; $ppH->[1] = 1; } if ($ppH->[1]=~$qnH and $gcH->[1]=~$qnH) {  ($ppH->[1],$gcH->[1]) = znH($ppH->[1],$gcH->[1]); ($ppH->[1],$gcH->[1]) = sxH($ppH->[1],$gcH->[1]); } } my $paH = ''; $paH .= $gcH->[$_] foreach (1..8); $gcH->[0] = '' unless $paH=~/./;  print $wuH."end ymH()  '@$ppH'  '@$gcH' \n" and $wuH=~s/$awH//  if $O_I::DEBUG=~/8/; } sub nyH { my ( $i1H, $qhH ) = @_;
my $qpH = $$qhH; return  unless "1/$qpH"=~$qkH; $wuH .=$awH and print $wuH."begin nyH() '@$i1H'  '$$qhH' \n" if $O_I::DEBUG=~/f/; my ($mfH, $gdH) = ('',''); if ( $qpH=~/^(\d+)(.*)|(\d*)(.+)$/ ) {  $mfH = $1; $mfH ||= ''; $gdH = $2;  $gdH ||= ''; } unless ($mfH) {  print $wuH."end 1 nyH() '@$i1H'  '$$qhH' \n" and $wuH=~s/$awH//  if $O_I::DEBUG=~/f/; return } my $ftH = xpH ($mfH); foreach ( @$i1H ) { next unless $_;  my $bkH = ''; $bkH = $2 if (/^(-?)(\d+)(.*)|(-?)(\d*)(.+)$/) ;  $bkH ||= 1;
my $tfH = xpH ($bkH); foreach ( keys %$ftH ) { if (not exists $tfH->{$_}) { $ftH->{$_} = 0;  } elsif ($tfH->{$_} < $ftH->{$_}) { $ftH->{$_} = $tfH->{$_}; } } } my $nlH = 1; foreach ( keys %$ftH ) { next unless $_;  $nlH *= $_ ** $ftH->{$_} ; } if ($nlH > 1) { foreach ( @$i1H ) { next unless $_; my ($lxH, $bkH, $e1H) = ('','',''); if ( /^(-?)(\d+)(.*)|(-?)(\d*)(.+)$/) {
$lxH = $1;  $lxH ||= ''; my $bkH = $2; $bkH ||= ''; my $e1H = $3;  $e1H ||= ''; $bkH = $bkH/$nlH; $_ = "$lxH$bkH$e1H"; } else {}  } $mfH = $mfH/$nlH; $$qhH = "$mfH$gdH"; } print $wuH."end nyH()  '@$i1H'  '$$qhH' \n" and $wuH=~s/$awH//  if $O_I::DEBUG=~/f/; } sub xpH { my $ppH = shift; my %btH = (); foreach (@cqH) { last if $_ > $ppH; until ( $ppH%$_ ) {
$btH{$_}++ ; $ppH = $ppH/$_; } } return \%btH; } sub vkH { my $qcH = shift; return ($qcH, '') if $qcH!~/î/; return ('', $qcH) if $qcH=~/^(-?[\w∙]*?î.*)$/;  $qcH =~/^(.+?)([\+-]{1,}.*?î.*)$/;  my $nxH = $1;  my $svH = $2;  $svH =~s/^\+// if $svH; return ($nxH, $svH);  } sub yjH {$_[0]} 1;
__DATA__
5K7ZDY4rEIxKhO8nANWVzg
